import { __awaiter } from 'tslib';
import { Input, HostBinding, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, Renderer2, ChangeDetectorRef, Output, HostListener, Injectable, ɵɵdefineInjectable, Directive, TemplateRef, ContentChild, Optional, ViewChild, Pipe, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { FormGroup, FormArray, Validators, FormControl, FormGroupDirective, ReactiveFormsModule, FormsModule } from '@angular/forms';
import { evalToBool } from '@anjuna/core';
import { AnjunaValidators, BaseTranslationPipe, AnjunaCoreModule } from '@anjuna/angular-core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/* @internal */
/**
 * @abstract
 */
class BaseSchema {
    /**
     * @return {?}
     */
    get hideLabels() {
        return this._hideLabels;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set hideLabels(value) {
        if (typeof value === 'string') {
            this._hideLabels = evalToBool(value);
        }
        else {
            this._hideLabels = value;
        }
    }
    /**
     * @param {?} index
     * @return {?}
     */
    trackByFn(index) {
        return index;
    }
}
BaseSchema.propDecorators = {
    hideLabels: [{ type: Input }],
    _hideLabels: [{ type: HostBinding, args: ['attr.hideLabel',] }]
};
if (false) {
    /** @type {?} */
    BaseSchema.prototype._hideLabels;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ParsedField {
    /**
     * @param {?} name
     * @param {?} fieldDef
     * @param {?=} requiredFields
     * @param {?=} readonlyFields
     * @param {?=} relationships
     */
    constructor(name, fieldDef, requiredFields = [], readonlyFields = [], relationships = []) {
        this.default = fieldDef.default;
        this.description = fieldDef.description;
        this.enforceUnique = fieldDef.uniqueItems;
        this.format = fieldDef.format;
        this.items = fieldDef.items;
        this.label = fieldDef.title || fieldDef.label || name;
        this.maximum = fieldDef.maximum;
        this.maxItems = fieldDef.maxItems;
        this.maxLength = fieldDef.maxLength;
        this.minimum = fieldDef.minimum;
        this.minItems = fieldDef.minItems;
        this.minLength = fieldDef.minLength;
        this.name = name;
        this.nestedDef = fieldDef;
        this.options = fieldDef.enum;
        this.pattern = fieldDef.pattern;
        this.parsedArray = fieldDef.parsedArray;
        this.parsedList = fieldDef.parsedList;
        this.parsedFields = fieldDef.parsedFields;
        this.properties = fieldDef.properties;
        this.readonly = fieldDef.readonly || (readonlyFields ? readonlyFields.includes(name) : false);
        this.required = requiredFields ? requiredFields.includes(name) : false;
        this.subtype = fieldDef.subtype;
        this.type = fieldDef.type;
        this.uoms = fieldDef.UOMs;
        this.uom = fieldDef.UOM;
        this.relationships = relationships;
    }
    /**
     * @return {?}
     */
    toInputType() {
        if (this.format === 'date') {
            return 'date';
        }
        else if (this.options) {
            return 'select';
        }
        else if (this.type === 'integer' || this.type === 'number') {
            return 'number';
        }
        else if (this.type === 'boolean') {
            return 'checkbox';
        }
        else if (this.type === 'array' && this.subtype === 'tier') {
            return 'tier';
        }
        else if (this.type === 'array' && this.items && this.items.type === 'object') {
            return 'table';
        }
        else if (this.type === 'array' && this.items) {
            return 'list';
        }
        else if (this.type === 'object' && this.properties) {
            return 'nested';
        }
        else if (this.type === 'string' && this.subtype === 'area') {
            return 'area';
        }
        else if (this.format === 'uuid' &&
            this.relationships.some((/**
             * @param {?} r
             * @return {?}
             */
            (r) => Object.keys(r.fields).includes(this.name)))) {
            return 'relationship';
        }
        return 'text';
    }
}
if (false) {
    /** @type {?} */
    ParsedField.prototype.parent;
    /** @type {?} */
    ParsedField.prototype.control;
    /** @type {?} */
    ParsedField.prototype.default;
    /** @type {?} */
    ParsedField.prototype.description;
    /** @type {?} */
    ParsedField.prototype.enforceUnique;
    /** @type {?} */
    ParsedField.prototype.format;
    /** @type {?} */
    ParsedField.prototype.items;
    /** @type {?} */
    ParsedField.prototype.label;
    /** @type {?} */
    ParsedField.prototype.options;
    /** @type {?} */
    ParsedField.prototype.minItems;
    /** @type {?} */
    ParsedField.prototype.maxItems;
    /** @type {?} */
    ParsedField.prototype.minLength;
    /** @type {?} */
    ParsedField.prototype.maxLength;
    /** @type {?} */
    ParsedField.prototype.minimum;
    /** @type {?} */
    ParsedField.prototype.maximum;
    /** @type {?} */
    ParsedField.prototype.name;
    /** @type {?} */
    ParsedField.prototype.nestedDef;
    /** @type {?} */
    ParsedField.prototype.parsedArray;
    /** @type {?} */
    ParsedField.prototype.parsedList;
    /** @type {?} */
    ParsedField.prototype.parsedFields;
    /** @type {?} */
    ParsedField.prototype.pattern;
    /** @type {?} */
    ParsedField.prototype.properties;
    /** @type {?} */
    ParsedField.prototype.readonly;
    /** @type {?} */
    ParsedField.prototype.required;
    /** @type {?} */
    ParsedField.prototype.subtype;
    /** @type {?} */
    ParsedField.prototype.type;
    /** @type {?} */
    ParsedField.prototype.uoms;
    /** @type {?} */
    ParsedField.prototype.uom;
    /** @type {?} */
    ParsedField.prototype.relationships;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/* @internal */
/**
 * @abstract
 */
class SchemaField extends BaseSchema {
    constructor() {
        super();
        this.isField = true;
    }
}
SchemaField.propDecorators = {
    field: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    SchemaField.prototype.field;
    /**
     * @type {?}
     * @protected
     */
    SchemaField.prototype.isField;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaFieldComponent extends SchemaField {
    /**
     * @param {?} element
     * @param {?} renderer
     * @param {?} changeRef
     */
    constructor(element, renderer, changeRef) {
        super();
        this.element = element;
        this.renderer = renderer;
        this.changeRef = changeRef;
        this.tierToChange = new EventEmitter();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _onFieldChange(event) {
        if (this.field.name === 'tierTo') {
            this.tierToChange.emit(this.index);
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.renderer.addClass(this.element.nativeElement, this.field.name.split(' ').join('_'));
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    handleOnChangeCallback({ detail }) {
        return __awaiter(this, void 0, void 0, /** @this {!SchemaFieldComponent} */ function* () {
            if (this.inputChangeCallback) {
                this.typeaheadOptions = yield this.inputChangeCallback(detail);
                this.changeRef.markForCheck();
            }
        });
    }
}
SchemaFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-field',
                template: "<ng-container [ngSwitch]=\"field.toInputType()\">\n    <ng-template ngSwitchCase=\"relationship\">\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"!field.required\">{{field.label}}</anj-label>\n            <anj-type-ahead (anjQuery)=\"handleOnChangeCallback($event)\" [formControl]=\"control\" display=\"label\">\n                <anj-option *ngFor=\"let option of typeaheadOptions\" [value]=\"option\">\n                    {{option.label}}\n                </anj-option>\n            </anj-type-ahead>\n        </anj-form-group>\n        <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n    </ng-template>\n    <ng-template ngSwitchCase=\"date\">\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"!field.required\">{{field.label}}</anj-label>\n            <anj-input [formControl]=\"control\" placeholder=\"{{hideLabels ? field.name : null}}\" [min]=\"field.minimum\"\n                [max]=\"field.maximum\" [attr.readonly]=\"field.readonly\" [attr.required]=\"field.required\">\n                <anj-date-picker-toggle></anj-date-picker-toggle>\n                <anj-date-picker></anj-date-picker>\n            </anj-input>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors?.required\">\n                    {{field.label || field.name}} {{'is required.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors?.date?.valid === false\">\n                    {{field.label || field.name}} {{'is not a valid date.' | anjSchemaTranslate}}\n                </anj-form-error>\n            </ng-template>\n            <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n        </anj-form-group>\n    </ng-template>\n    <ng-template ngSwitchCase=\"select\">\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"!field.required\">{{field.label}}</anj-label>\n            <anj-select placeholder=\"{{hideLabels ? field.name : null}}\" [formControl]=\"control\"\n                [attr.required]=\"field.required\">\n                <anj-option *ngFor=\"let option of field.options\" [value]=\"option\">{{option}}</anj-option>\n                <ng-template [ngIf]=\"control.errors\">\n                    <anj-form-error>{{'Please select an option.' | anjSchemaTranslate}}</anj-form-error>\n                </ng-template>\n            </anj-select>\n            <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n        </anj-form-group>\n    </ng-template>\n    <ng-template ngSwitchCase=\"number\">\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"!field.required\">{{field.label}}</anj-label>\n            <anj-input [formControl]=\"control\" step=\"1\" type=\"number\" placeholder=\"{{hideLabels ? field.name : null}}\"\n                [min]=\"field.minimum\" [max]=\"field.maximum\" [attr.readonly]=\"field.readonly\"\n                [attr.required]=\"field.required\">\n                <anj-number-stepper></anj-number-stepper>\n            </anj-input>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors?.required\">\n                    {{field.label || field.name}} {{'is required.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors?.min\">\n                    {{field.label || field.name}} {{'must be at least' | anjSchemaTranslate}}\n                    {{control.errors.min.min}}.\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors?.max\">\n                    {{field.label || field.name}} {{'must not be greater than' | anjSchemaTranslate}}\n                    {{control.errors.max.max}}.\n                </anj-form-error>\n            </ng-template>\n            <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n        </anj-form-group>\n    </ng-template>\n    <ng-template ngSwitchCase=\"checkbox\">\n        <anj-check-group>\n            <anj-checkbox [formControl]=\"control\">{{field.label}}</anj-checkbox>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors?.required\">\n                    {{field.label || field.name}} {{'is required.' | anjSchemaTranslate}}\n                </anj-form-error>\n            </ng-template>\n        </anj-check-group>\n    </ng-template>\n    <ng-template ngSwitchCase=\"list\">\n        <anj-form-group>\n            <anj-list [field]=\"field\" [control]=\"control\" [label]=\"!hideLabels ? field.label: null\"\n                [attr.required]=\"field.required\"></anj-list>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors?.unique\">\n                    {{field.label || field.name}} {{'must not have duplicate values.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors?.minlength\">\n                    {{field.label || field.name}} {{'must have at least' | anjSchemaTranslate}}\n                    {{control.errors['minlength'].requiredLength}} {{'entries.' | anjSchemaTranslate}}\n                </anj-form-error>\n            </ng-template>\n        </anj-form-group>\n    </ng-template>\n    <ng-template ngSwitchCase=\"nested\">\n        <anj-schema-nested-field [field]=\"field\" [control]=\"control\" [label]=\"!hideLabels ? field.label: null\">\n        </anj-schema-nested-field>\n    </ng-template>\n    <ng-template ngSwitchCase=\"table\">\n        <anj-schema-table [field]=\"field\" [control]=\"control\" [label]=\"!hideLabels ? field.label: null\">\n        </anj-schema-table>\n    </ng-template>\n    <ng-template ngSwitchCase=\"tier\">\n        <anj-schema-tier [field]=\"field\" [control]=\"control\" [label]=\"!hideLabels ? field.label: null\">\n        </anj-schema-tier>\n    </ng-template>\n    <ng-template ngSwitchCase=\"area\">\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"!field.required\">{{field.label}}</anj-label>\n            <anj-textarea [formControl]=\"control\" placeholder=\"{{hideLabels ? field.name : null}}\"\n                [attr.readonly]=\"field.readonly\" [attr.required]=\"field.required\"></anj-textarea>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors.required\">\n                    {{field.label || field.name}} {{'is required.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.minlength\">\n                    {{field.label || field.name}} {{'must be at least' | anjSchemaTranslate}}\n                    {{control.errors.minlength.requiredLength}} {{'characters.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.maxlength\">\n                    {{field.label || field.name}} {{'must not be greater than' | anjSchemaTranslate}}\n                    {{control.errors.maxlength.requiredLength}} {{'characters.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.pattern\">\n                    {{field.label || field.name}}\n                    {{'must adhere to a specific pattern' | anjSchemaTranslate}}{{field.description ? ': ' + field.description : null}}\n                </anj-form-error>\n            </ng-template>\n            <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n        </anj-form-group>\n    </ng-template>\n    <ng-template ngSwitchDefault>\n        <anj-form-group>\n            <anj-label *ngIf=\"!hideLabels\" [optional]=\"false\">{{field.label}}</anj-label>\n            <anj-input [formControl]=\"control\" placeholder=\"{{hideLabels ? field.name : null}}\"\n                [attr.readonly]=\"field.readonly\" [attr.required]=\"field.required\"></anj-input>\n            <ng-template [ngIf]=\"control.errors\">\n                <anj-form-error *ngIf=\"control.errors.required\">\n                    {{field.label || field.name}} {{'is required.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.minlength\">\n                    {{field.label || field.name}} {{'must be at least' | anjSchemaTranslate}}\n                    {{control.errors.minlength.requiredLength}} {{'characters.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.maxlength\">\n                    {{field.label || field.name}} {{'must not be greater than' | anjSchemaTranslate}}\n                    {{control.errors.maxlength.requiredLength}} {{'characters.' | anjSchemaTranslate}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.pattern\">\n                    {{field.label || field.name}}\n                    {{'must adhere to a specific pattern' | anjSchemaTranslate}}{{field.description ? ': ' + field.description : null}}\n                </anj-form-error>\n                <anj-form-error *ngIf=\"control.errors.email\">\n                    {{field.label || field.name}}\n                    {{'must adhere to an email pattern (ex. name@domain.com)' | anjSchemaTranslate}}\n                </anj-form-error>\n            </ng-template>\n            <anj-form-helper *ngIf=\"field.description\">{{field.description}}</anj-form-helper>\n        </anj-form-group>\n    </ng-template>\n</ng-container>",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
SchemaFieldComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 },
    { type: ChangeDetectorRef }
];
SchemaFieldComponent.propDecorators = {
    control: [{ type: Input }],
    index: [{ type: Input }],
    inputChangeCallback: [{ type: Input }],
    tierToChange: [{ type: Output }],
    isField: [{ type: HostBinding, args: [`class.anj-schema-field`,] }],
    _onFieldChange: [{ type: HostListener, args: ['anjChange', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    SchemaFieldComponent.prototype.control;
    /** @type {?} */
    SchemaFieldComponent.prototype.index;
    /** @type {?} */
    SchemaFieldComponent.prototype.inputChangeCallback;
    /** @type {?} */
    SchemaFieldComponent.prototype.tierToChange;
    /** @type {?} */
    SchemaFieldComponent.prototype.typeaheadOptions;
    /** @type {?} */
    SchemaFieldComponent.prototype.isField;
    /**
     * @type {?}
     * @private
     */
    SchemaFieldComponent.prototype.element;
    /**
     * @type {?}
     * @private
     */
    SchemaFieldComponent.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    SchemaFieldComponent.prototype.changeRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaFormService {
    /**
     * \@description Recursively parses a raw JSON schema into an array of parsed fields the UI can work with.
     * @param {?} fieldDefs
     * @return {?}
     */
    static parseSchema(fieldDefs) {
        /** @type {?} */
        const parsedFields = [];
        /** @type {?} */
        const fields = (/** @type {?} */ (fieldDefs.properties));
        for (const propertyName in fields) {
            if (fields[propertyName]) {
                /** @type {?} */
                const prop = fields[propertyName];
                // Make all nested fields required if the parent object is required
                if (prop.type === 'object') {
                    prop.required = (fieldDefs.required.includes(propertyName)) ? Object.keys(prop.properties) : [];
                }
                // Handle for table array
                if (prop.type === 'array' && prop.items && prop.items.type === 'object' && prop.items.properties) {
                    prop.parsedArray = SchemaFormService.parseSchema(prop.items);
                }
                else if (prop.type === 'array') {
                    /** @type {?} */
                    let cloneProp = Object.assign({}, prop);
                    cloneProp = Object.assign(cloneProp, prop.items);
                    prop.parsedList = new ParsedField(propertyName, cloneProp);
                }
                else if (prop.type === 'object' && prop.properties) {
                    prop.parsedFields = SchemaFormService.parseSchema(prop);
                }
                parsedFields.push(new ParsedField(propertyName, prop, fieldDefs.required, fieldDefs.readOnlyOnUI, fieldDefs.relationships));
            }
        }
        return parsedFields;
    }
    /**
     * \@description Parses a tuple of raw JSON and Data object [SchemaDefinition, SchemaData] into a [ParsedField[], FormGroup].
     * @param {?} payload
     * @return {?}
     */
    static parseSchemaPayload(payload) {
        /** @type {?} */
        const data = payload[1];
        /** @type {?} */
        const fields = SchemaFormService.parseSchema(payload[0]);
        /** @type {?} */
        const group = SchemaFormService.generateFormGroup(fields, data);
        return [fields, group];
    }
    /**
     * \@description Recursively generates a formGroup from a ParsedField[], setting any default data provided.
     * @param {?} fields
     * @param {?} data
     * @return {?}
     */
    static generateFormGroup(fields, data) {
        /** @type {?} */
        const group = new FormGroup({});
        /** @type {?} */
        let i = 1;
        fields.forEach((/**
         * @param {?} field
         * @return {?}
         */
        field => {
            /** @type {?} */
            const initialValue = data && data.hasOwnProperty(field.name) ? data[field.name] : field.default;
            // Handle for table array
            if (Array.isArray(field.parsedArray)) {
                /** @type {?} */
                const newFormArray = new FormArray([], Validators.compose(SchemaFormService.setValidators(field)));
                if (data && data[field.name]) {
                    data[field.name].forEach((/**
                     * @param {?} dataValue
                     * @return {?}
                     */
                    (dataValue) => {
                        newFormArray.push(SchemaFormService.generateFormGroup(field.parsedArray, dataValue));
                    }));
                }
                group.addControl(field.name, newFormArray);
            }
            else if (field.parsedList) { // Handle for list array
                // Handle for list array
                /** @type {?} */
                const newFormArray = new FormArray([], Validators.compose(SchemaFormService.setValidators(field)));
                if (data && data[field.name]) {
                    data[field.name].forEach((/**
                     * @param {?} dataValue
                     * @return {?}
                     */
                    (dataValue) => {
                        newFormArray.push(new FormControl(dataValue, SchemaFormService.setValidators(field.parsedList)));
                    }));
                }
                group.addControl(field.name, newFormArray);
            }
            else if (Array.isArray(field.parsedFields)) { // Handle for nested schema
                // Handle for nested schema
                /** @type {?} */
                const nestedGroup = SchemaFormService.generateFormGroup(field.parsedFields, initialValue);
                group.addControl(field.name, nestedGroup);
                i++;
            }
            else {
                group.addControl(field.name, new FormControl(initialValue, SchemaFormService.setValidators(field)));
            }
        }));
        return group;
    }
    /**
     * \@description Adds the correct validators to each field pending on its type and whether it is required.
     * @param {?} definition
     * @return {?}
     */
    static setValidators(definition) {
        /** @type {?} */
        const validators = [];
        if (definition.required && definition.type === 'boolean') {
            validators.push(AnjunaValidators.requiredCheck);
        }
        else if (definition.required) {
            validators.push(Validators.required);
        }
        if (!isNaN(definition.maximum)) {
            validators.push(Validators.max(definition.maximum));
        }
        if (!isNaN(definition.minimum)) {
            validators.push(Validators.min(definition.minimum));
        }
        if (!isNaN(definition.minLength)) {
            validators.push(Validators.minLength(definition.minLength));
        }
        if (!isNaN(definition.maxLength)) {
            validators.push(Validators.maxLength(definition.maxLength));
        }
        if (definition.format === 'email') {
            validators.push(Validators.email);
        }
        if (definition.pattern) {
            validators.push(Validators.pattern(definition.pattern));
        }
        if (definition.format && definition.format === 'date') {
            validators.push(AnjunaValidators.date);
        }
        if (definition.enforceUnique) {
            validators.push(AnjunaValidators.unique);
        }
        if (!isNaN(definition.minItems) && definition.type === 'array') {
            validators.push(Validators.minLength(definition.minItems));
        }
        return validators;
    }
    /**
     * \@description Parses the keys for generating the table renderer
     * @param {?} field
     * @return {?}
     */
    static parseFieldItemKeys(field) {
        if (field.items && field.items.properties) {
            return Object.keys(field.items.properties);
        }
        return [];
    }
}
SchemaFormService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ SchemaFormService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SchemaFormService_Factory() { return new SchemaFormService(); }, token: SchemaFormService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaForm {
    /**
     * @param {?} schema
     * @param {?} data
     */
    constructor(schema, data) {
        this.fields = {};
        this.fieldNames = [];
        /** @type {?} */
        const payload = SchemaFormService.parseSchemaPayload([schema, data]);
        this.schema = schema;
        this.data = data;
        this.formGroup = payload[1];
        this.formFields = payload[0].map((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            field.control = this.formGroup.controls[field.name];
            if (field.parsedFields && field.parsedFields.length > 0) {
                this.setFieldParents(field.parsedFields, field);
                this.flattenFields(field.parsedFields, field.control);
            }
            this.fields[field.name] = field;
            return field;
        }));
        this.fieldNames = Object.keys(this.fields).filter((/**
         * @param {?} name
         * @return {?}
         */
        name => (this.fields[name].control !== undefined)));
    }
    /**
     * @private
     * @param {?} fields
     * @param {?} formGroup
     * @return {?}
     */
    flattenFields(fields, formGroup) {
        fields.forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            if (field.parsedFields && field.parsedFields.length > 0) {
                this.flattenFields(field.parsedFields, field.control);
            }
            else {
                if (field.type !== 'array') {
                    field.control = this.findFormControl(field);
                }
                else {
                    field.control = ((/** @type {?} */ (formGroup))).controls[field.name];
                }
                this.fields[field.name] = field;
            }
        }));
        return fields;
    }
    /**
     * @private
     * @param {?} field
     * @return {?}
     */
    findFormControl(field) {
        /** @type {?} */
        const parentName = field.parent.name;
        /** @type {?} */
        let control;
        /** @type {?} */
        let parent = field.parent;
        while (parent && !control) {
            /** @type {?} */
            const parentControl = parent.control;
            if (parent
                && parentControl
                && ((/** @type {?} */ (parentControl))).controls
                && (parentName in ((/** @type {?} */ (parent.control))).controls)) {
                control = ((/** @type {?} */ (((/** @type {?} */ (parent.control))).controls[parentName]))).controls[field.name];
            }
            else {
                parent = parent.parent;
            }
        }
        return control;
    }
    /**
     * @private
     * @param {?} fields
     * @param {?} parent
     * @return {?}
     */
    setFieldParents(fields, parent) {
        fields.forEach((/**
         * @param {?} field
         * @return {?}
         */
        field => {
            field.parent = parent;
            if (field.parsedFields && field.parsedFields.length > 0) {
                this.setFieldParents(field.parsedFields, field);
            }
        }));
    }
}
if (false) {
    /** @type {?} */
    SchemaForm.prototype.schema;
    /** @type {?} */
    SchemaForm.prototype.data;
    /** @type {?} */
    SchemaForm.prototype.formGroup;
    /** @type {?} */
    SchemaForm.prototype.fields;
    /** @type {?} */
    SchemaForm.prototype.fieldNames;
    /**
     * @type {?}
     * @private
     */
    SchemaForm.prototype.formFields;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FieldTemplateDirective {
    /**
     * @param {?} _template
     */
    constructor(_template) {
        this._template = _template;
    }
    /**
     * @return {?}
     */
    get template() {
        return this._template;
    }
}
FieldTemplateDirective.decorators = [
    { type: Directive, args: [{
                selector: '[anjFieldTemplate]'
            },] }
];
/** @nocollapse */
FieldTemplateDirective.ctorParameters = () => [
    { type: TemplateRef }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    FieldTemplateDirective.prototype._template;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/* @internal */
/**
 * @abstract
 */
class SchemaControl extends BaseSchema {
    /**
     * @protected
     * @return {?}
     */
    handleChanges() {
        if (this.data && this.schema) {
            this.initGroup();
        }
    }
}
SchemaControl.propDecorators = {
    schema: [{ type: Input }],
    data: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    SchemaControl.prototype.schema;
    /** @type {?} */
    SchemaControl.prototype.data;
    /** @type {?} */
    SchemaControl.prototype.parsedFields;
    /**
     * @abstract
     * @protected
     * @return {?}
     */
    SchemaControl.prototype.initGroup = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaFormComponent extends SchemaControl {
    constructor() {
        super();
        this.valueChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.handleChanges();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.groupSubscription) {
            this.groupSubscription.unsubscribe();
        }
    }
    /**
     * \@description initializes a schema payload imperatively
     * @param {?} schemaForm
     * @return {?}
     */
    initSchemaForm(schemaForm) {
        // Bind them to the component
        this.schemaPayload = schemaForm;
        if (this.schemaPayload) {
            this.groupSubscription = this.schemaPayload.formGroup.valueChanges.subscribe({
                next: (/**
                 * @param {?} value
                 * @return {?}
                 */
                (value) => {
                    this.valueChange.emit(value);
                })
            });
        }
    }
    /**
     * @protected
     * @return {?}
     */
    initGroup() {
        this.initSchemaForm(new SchemaForm(this.schema, this.data));
    }
}
SchemaFormComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-form',
                template: "<ng-container *ngIf=\"schemaPayload && fieldTemplate\">\n    <ng-template [ngTemplateOutlet]=\"fieldTemplate?.template\" [ngTemplateOutletContext]=\"{$implicit: schemaPayload.fields, form: schemaPayload.formGroup, fieldNames: schemaPayload.fieldNames}\"></ng-template>\n</ng-container>\n<ng-content select=\"anj-button-group\"></ng-content>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
SchemaFormComponent.ctorParameters = () => [];
SchemaFormComponent.propDecorators = {
    schemaPayload: [{ type: Input }],
    valueChange: [{ type: Output }],
    fieldTemplate: [{ type: ContentChild, args: [FieldTemplateDirective, { static: false },] }]
};
if (false) {
    /** @type {?} */
    SchemaFormComponent.prototype.schemaPayload;
    /** @type {?} */
    SchemaFormComponent.prototype.valueChange;
    /** @type {?} */
    SchemaFormComponent.prototype.fieldTemplate;
    /**
     * @type {?}
     * @private
     */
    SchemaFormComponent.prototype.groupSubscription;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/* @internal */
/**
 * @abstract
 */
class SchemaGroup extends BaseSchema {
    /**
     * @return {?}
     */
    get groupClass() { return this._groupClass || ''; }
    /**
     * @param {?} value
     * @return {?}
     */
    set groupClass(value) {
        this._groupClass = value;
    }
    /**
     * @return {?}
     */
    get fieldClass() { return this._fieldClass || ''; }
    /**
     * @param {?} value
     * @return {?}
     */
    set fieldClass(value) {
        this._fieldClass = value;
    }
    /**
     * @protected
     * @return {?}
     */
    handleChanges() {
        if (this.group) {
            this.initGroup();
        }
    }
}
SchemaGroup.propDecorators = {
    groupClass: [{ type: Input }],
    fieldClass: [{ type: Input }],
    group: [{ type: Input }],
    _fieldClass: [{ type: HostBinding, args: ['attr.fieldClass',] }],
    _groupClass: [{ type: HostBinding, args: ['attr.groupClass',] }]
};
if (false) {
    /** @type {?} */
    SchemaGroup.prototype.group;
    /** @type {?} */
    SchemaGroup.prototype._fieldClass;
    /** @type {?} */
    SchemaGroup.prototype._groupClass;
    /** @type {?} */
    SchemaGroup.prototype.parsedFields;
    /**
     * @abstract
     * @protected
     * @return {?}
     */
    SchemaGroup.prototype.initGroup = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaGroupComponent extends SchemaGroup {
    /**
     * @param {?} changeRef
     * @param {?} parentGroup
     */
    constructor(changeRef, parentGroup) {
        super();
        this.changeRef = changeRef;
        this.parentGroup = parentGroup;
        // Define the form group when initialized so that it is defined when needed as a view child property
        this.formGroup = new FormGroup({});
        this.valueChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    get classList() {
        return `anj-schema-group ${this.groupClass}`;
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.handleChanges();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.groupSubscription) {
            this.groupSubscription.unsubscribe();
        }
    }
    /**
     * \@description initializes a schema group imperatively
     * @param {?} __0
     * @return {?}
     */
    initFormGroup([fields, group]) {
        // Bind them to the component
        this.parsedFields = fields;
        this.formGroup = group;
        // Integrate to existing parent formGroup, if available
        if (this.parentGroup && this.parentGroup.control) {
            Object.keys(group.controls).forEach((/**
             * @param {?} key
             * @return {?}
             */
            key => {
                this.parentGroup.control.addControl(key, group.controls[key]);
            }));
            this.formGroup = this.parentGroup.control;
        }
        this.groupSubscription = this.formGroup.valueChanges.subscribe({
            next: (/**
             * @param {?} value
             * @return {?}
             */
            (value) => {
                this.valueChange.emit(value);
            })
        });
    }
    /**
     * @param {?} fieldName
     * @return {?}
     */
    getInputChangeCallback(fieldName) {
        return this.onInputChangeCallbacks ? this.onInputChangeCallbacks[fieldName] : undefined;
    }
    /**
     * @protected
     * @return {?}
     */
    initGroup() {
        this.initFormGroup(SchemaFormService.parseSchemaPayload(this.group));
    }
}
SchemaGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-group',
                template: "<ng-container *ngIf=\"parsedFields\">\n    <anj-schema-field *ngFor=\"let field of parsedFields; trackBy: trackByFn;\" [field]=\"field\"\n        [control]=\"formGroup.controls[field.name]\" [inputChangeCallback]=\"getInputChangeCallback(field.name)\"\n        class=\"{{fieldClass}}\" [hideLabels]=\"hideLabels\"></anj-schema-field>\n</ng-container>",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
SchemaGroupComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: FormGroupDirective, decorators: [{ type: Optional }] }
];
SchemaGroupComponent.propDecorators = {
    onInputChangeCallbacks: [{ type: Input }],
    valueChange: [{ type: Output }],
    classList: [{ type: HostBinding, args: ['class',] }]
};
if (false) {
    /**
     * an object full of keys corresponding to field names
     * ex: custom_field__c
     * matched to functions that return a promise,
     * well suited for onChange, onClick, onDrag event situations
     * @type {?}
     */
    SchemaGroupComponent.prototype.onInputChangeCallbacks;
    /** @type {?} */
    SchemaGroupComponent.prototype.valueChange;
    /** @type {?} */
    SchemaGroupComponent.prototype.formGroup;
    /**
     * @type {?}
     * @private
     */
    SchemaGroupComponent.prototype.groupSubscription;
    /**
     * @type {?}
     * @private
     */
    SchemaGroupComponent.prototype.changeRef;
    /**
     * @type {?}
     * @private
     */
    SchemaGroupComponent.prototype.parentGroup;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaNestedFieldComponent extends SchemaField {
    constructor() {
        super();
    }
    /**
     * @return {?}
     */
    get label() {
        return this._label || '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set label(value) {
        this._label = value;
    }
    /**
     * @param {?} newValue
     * @return {?}
     */
    updateNestedField(newValue) {
        this.control.patchValue(newValue);
    }
}
SchemaNestedFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-nested-field',
                template: "<anj-form-group>\n    <anj-label *ngIf=\"!hideLabels\" [fixed]=\"true\">{{label}}</anj-label>\n</anj-form-group>\n<div class=\"anj-nested\">\n    <ng-container [formGroup]=\"control\">\n        <anj-schema-field *ngFor=\"let nestedField of field.parsedFields; trackBy: trackByFn;\"\n                          [field]=\"nestedField\"\n                          [control]=\"control['controls'][nestedField.name]\"\n        ></anj-schema-field>\n    </ng-container>\n</div>\n\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                styles: ["anj-schema-nested-field .anj-nested{margin:0 0 1rem 1rem}anj-schema-nested-field .anj-form-group.anj-has-value{margin:0}"]
            }] }
];
/** @nocollapse */
SchemaNestedFieldComponent.ctorParameters = () => [];
SchemaNestedFieldComponent.propDecorators = {
    control: [{ type: Input }],
    label: [{ type: Input }],
    isField: [{ type: HostBinding, args: ['class.anj-schema-nested-field',] }]
};
if (false) {
    /** @type {?} */
    SchemaNestedFieldComponent.prototype.control;
    /** @type {?} */
    SchemaNestedFieldComponent.prototype.isField;
    /**
     * @type {?}
     * @private
     */
    SchemaNestedFieldComponent.prototype._label;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReadFieldComponent extends SchemaField {
    /**
     * @param {?} element
     * @param {?} renderer
     */
    constructor(element, renderer) {
        super();
        this.element = element;
        this.renderer = renderer;
    }
    /**
     * @return {?}
     */
    get fieldItemPropertiesKeys() {
        return SchemaFormService.parseFieldItemKeys(this.field);
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.renderer.addClass(this.element.nativeElement, this.field.name.split(' ').join('_'));
    }
    /**
     * @return {?}
     */
    toDisplayValue() {
        /** @type {?} */
        let displayValue = this.value ? this.value : '';
        if (Array.isArray(this.value)) {
            displayValue = this.value.join(', ');
        }
        return displayValue;
    }
}
ReadFieldComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-read-field',
                template: "<ng-container [ngSwitch]=\"field.toInputType()\">\n    <span *ngIf=\"!hideLabels\" class=\"anj-schema-label\">\n        {{field.label}}\n    </span>\n    <span class=\"anj-schema-display-value\" [ngClass]=\"{'nested': field.toInputType() === 'nested'}\">\n        <ng-template ngSwitchCase=\"date\">\n            {{value | date: 'shortDate'}}\n        </ng-template>\n        <ng-template ngSwitchCase=\"checkbox\">\n            <svg *ngIf=\"value\" xmlns=\"http://www.w3.org/2000/svg\" width=\"18\" height=\"18\" viewBox=\"0 0 18 18\">\n                <path d=\"M6.61 11.89L3.5 8.78 2.44 9.84 6.61 14l8.95-8.95L14.5 4z\"/>\n            </svg>\n        </ng-template>\n        <ng-template ngSwitchCase=\"table\">\n            <anj-table [dataSource]=\"value\">\n                <anj-column *ngFor=\"let key of fieldItemPropertiesKeys;\" [field]=\"key\"></anj-column>\n            </anj-table>\n        </ng-template>\n        <ng-template ngSwitchCase=\"nested\">\n            <anj-schema-read\n                [group]=\"[field.nestedDef, value]\"\n            ></anj-schema-read>\n        </ng-template>\n        <ng-template ngSwitchDefault>\n            {{toDisplayValue()}}\n        </ng-template>\n    </span>\n</ng-container>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                styles: [".anj-read-field{position:relative}.anj-read-field .nested{margin-left:1rem}.anj-read-field .anj-schema-label{color:var(--anj-neutral);font-size:.75rem;line-height:1;margin-bottom:0;position:relative;top:0}.anj-read-field .anj-schema-display-value{display:block;min-height:1.75rem}"]
            }] }
];
/** @nocollapse */
ReadFieldComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 }
];
ReadFieldComponent.propDecorators = {
    value: [{ type: Input }],
    isField: [{ type: HostBinding, args: ['class.anj-read-field',] }]
};
if (false) {
    /** @type {?} */
    ReadFieldComponent.prototype.value;
    /** @type {?} */
    ReadFieldComponent.prototype.isField;
    /**
     * @type {?}
     * @private
     */
    ReadFieldComponent.prototype.element;
    /**
     * @type {?}
     * @private
     */
    ReadFieldComponent.prototype.renderer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaReadComponent extends SchemaGroup {
    constructor() {
        super();
    }
    /**
     * @return {?}
     */
    get classList() {
        return `anj-schema-read ${this.groupClass}`;
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.handleChanges();
    }
    /**
     * @protected
     * @return {?}
     */
    initGroup() {
        this.parsedFields = SchemaFormService.parseSchema(this.group[0]);
        this.values = this.group[1] || {};
    }
}
SchemaReadComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-read',
                template: "<ng-container *ngIf=\"parsedFields\">\n    <anj-read-field *ngFor=\"let field of parsedFields\"\n        [field]=\"field\"\n        [value]=\"values[field.name]\"\n        class=\"{{fieldClass}}\"\n        [hideLabels]=\"hideLabels\"\n    ></anj-read-field>\n</ng-container>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
SchemaReadComponent.ctorParameters = () => [];
SchemaReadComponent.propDecorators = {
    classList: [{ type: HostBinding, args: ['class',] }]
};
if (false) {
    /** @type {?} */
    SchemaReadComponent.prototype.values;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/* @internal */
/**
 * @abstract
 */
class SchemaArray extends SchemaField {
    /**
     * @protected
     */
    constructor() {
        super();
    }
    /**
     * @return {?}
     */
    get controlArrayValue() {
        return this.control.value;
    }
    /**
     * @return {?}
     */
    get formArray() {
        return (/** @type {?} */ (this.control));
    }
    /**
     * @param {?=} additionalRows
     * @param {?=} insertPosition
     * @return {?}
     */
    addRow(additionalRows = 1, insertPosition) {
        for (let i = 0; i < additionalRows; i++) {
            /** @type {?} */
            const insertIndex = insertPosition !== undefined ? insertPosition : this.controlArrayValue.length;
            this.formArray.insert(insertIndex, this.newItem());
        }
        this.acknowledgeChange();
    }
    /**
     * @param {?} index
     * @return {?}
     */
    removeRow(index) {
        this.formArray.removeAt(index);
        this.acknowledgeChange();
    }
    /**
     * @return {?}
     */
    atMaxItems() {
        return this.field.maxItems && (this.control.length === this.field.maxItems);
    }
    /**
     * @return {?}
     */
    atMinItems() {
        return this.field.minItems && (this.control.length === this.field.minItems);
    }
    /**
     * @param {?} event
     * @param {?} popper
     * @param {?} content
     * @return {?}
     */
    showToolTip(event, popper, content) {
        clearTimeout(this.timer);
        this.content = content;
        popper.display((/** @type {?} */ (event.target)));
    }
    /**
     * @param {?} popper
     * @return {?}
     */
    hideToolTip(popper) {
        this.timer = window.setTimeout((/**
         * @return {?}
         */
        () => {
            popper.hide();
        }), 750);
    }
    /**
     * @protected
     * @return {?}
     */
    setArray() {
        // If minItems and data is array shorter than minItems, add more empty rows
        if (this.field.minItems &&
            (Array.isArray(this.controlArrayValue) && this.controlArrayValue.length < this.field.minItems)) {
            /** @type {?} */
            const additionalRows = this.field.minItems - this.controlArrayValue.length;
            this.addRow(additionalRows);
            // If Data is not an array, add minimum rows (minItems or 1)
        }
        else if (!Array.isArray(this.controlArrayValue)) {
            /** @type {?} */
            const additionalRows = (this.field.minItems > 0) ? this.field.minItems : 1;
            this.addRow(additionalRows);
        }
    }
}
SchemaArray.propDecorators = {
    control: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    SchemaArray.prototype.control;
    /** @type {?} */
    SchemaArray.prototype.content;
    /** @type {?} */
    SchemaArray.prototype.timer;
    /**
     * @abstract
     * @protected
     * @return {?}
     */
    SchemaArray.prototype.acknowledgeChange = function () { };
    /**
     * @abstract
     * @protected
     * @return {?}
     */
    SchemaArray.prototype.newItem = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaTableComponent extends SchemaArray {
    /**
     * @param {?} changeRef
     */
    constructor(changeRef) {
        super();
        this.changeRef = changeRef;
    }
    /**
     * @return {?}
     */
    get label() {
        return this._label || '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set label(value) {
        this._label = value;
    }
    // Listen to rows added on anj-table, modify the NG Control respectively
    /**
     * @param {?} event
     * @return {?}
     */
    _onRowAdd(event) {
        this.addRow(1, event.detail.index);
    }
    // Listen to rows removed on anj-table, modify the NG Control respectively
    /**
     * @param {?} event
     * @return {?}
     */
    _onRowRemove(event) {
        this.removeRow(event.detail.index);
    }
    /**
     * @return {?}
     */
    get fieldItemPropertiesKeys() {
        return SchemaFormService.parseFieldItemKeys(this.field);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.localControlValue = this.controlArrayValue;
        this.setArray();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.acknowledgeChange();
    }
    /**
     * @param {?} def
     * @return {?}
     */
    getDataType(def) {
        // TODO: we probably need to handle at least numbers too
        if (def.type === 'boolean') {
            return 'boolean';
        }
    }
    /**
     * @param {?} fields
     * @param {?} c
     * @return {?}
     */
    findIndex(fields, c) {
        return fields.findIndex((/**
         * @param {?} t
         * @return {?}
         */
        t => t.name === c.field));
    }
    /**
     * @protected
     * @return {?}
     */
    newItem() {
        return SchemaFormService.generateFormGroup(this.field.parsedArray, {});
    }
    /**
     * @protected
     * @return {?}
     */
    acknowledgeChange() {
        this.localControlValue = this.controlArrayValue.slice(0);
        this.changeRef.markForCheck();
    }
}
SchemaTableComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-table',
                template: "<anj-form-group class=\"anj-schema-table-label\">\n    <anj-label *ngIf=\"!hideLabels\" [fixed]=\"true\">{{label}}</anj-label>\n</anj-form-group>\n<anj-table [dataSource]=\"localControlValue\" column-width=\"auto-fix\" height=\"400px\">\n    <anj-editing\n        mode=\"batch\"\n        creating=\"true\"\n        deleting=\"true\"\n        saving=\"false\"\n        [deleteDisabled]=\"atMinItems()\"\n        [createDisabled]=\"atMaxItems()\"\n    ></anj-editing>\n    <anj-column *ngFor=\"let key of fieldItemPropertiesKeys; let index = index;\"\n                [dataType]=\"getDataType(field.parsedArray[index])\"\n                [field]=\"key\"\n                sortable=\"false\"\n                edit-template=\"controlTemplate\"\n    ></anj-column>\n    <ng-container *anjTemplate=\"let row of 'controlTemplate'; let i = index; let c = column;\">\n        <anj-schema-field\n            *ngIf=\"control.controls[i]\"\n            [field]=\"field.parsedArray[findIndex(field.parsedArray, c)]\"\n            [control]=\"control.controls[i]['controls'][c.field]\"\n            [hideLabels]=\"true\">\n        </anj-schema-field>\n    </ng-container>\n</anj-table>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                styles: ["anj-schema-table .anj-schema-table-label{margin-top:1rem}anj-schema-table anj-schema-field{display:block}"]
            }] }
];
/** @nocollapse */
SchemaTableComponent.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
SchemaTableComponent.propDecorators = {
    label: [{ type: Input }],
    isField: [{ type: HostBinding, args: ['class.anj-schema-table',] }],
    _onRowAdd: [{ type: HostListener, args: ['anjCreateStart', ['$event'],] }],
    _onRowRemove: [{ type: HostListener, args: ['anjDelete', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    SchemaTableComponent.prototype.localControlValue;
    /**
     * @type {?}
     * @private
     */
    SchemaTableComponent.prototype._label;
    /** @type {?} */
    SchemaTableComponent.prototype.isField;
    /** @type {?} */
    SchemaTableComponent.prototype.changeRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaContextComponent extends BaseSchema {
    constructor() {
        super();
        this.valueChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    get groupClass() { return this._groupClass || ''; }
    /**
     * @param {?} value
     * @return {?}
     */
    set groupClass(value) {
        this._groupClass = value;
    }
    /**
     * @return {?}
     */
    get fieldClass() { return this._fieldClass || ''; }
    /**
     * @param {?} value
     * @return {?}
     */
    set fieldClass(value) {
        this._fieldClass = value;
    }
    /**
     * @return {?}
     */
    get mode() { return this._mode || 'view'; }
    /**
     * @param {?} value
     * @return {?}
     */
    set mode(value) {
        this._mode = value;
    }
    /**
     * @return {?}
     */
    get classList() {
        return `anj-schema-context anj-schema-context-${this.context}`;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    updateApp(event) {
        this.valueChange.emit(event);
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.schemaPayload = this.combinePayload();
    }
    /**
     * @private
     * @return {?}
     */
    combinePayload() {
        // Create Mode
        if (this.mode === 'create' && this.schema) {
            return [this.schema, null];
            // View Mode
        }
        else if (this.mode === 'view' && this.schema && !this.data) {
            return [this.schema, {}];
            // Update Mode
        }
        else if (this.schema && this.data) {
            return [this.schema, this.data];
        }
        return null;
    }
}
SchemaContextComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-context, anj-custom-fields',
                template: "<ng-container *ngIf=\"mode === 'view'; else formFields\">\n    <anj-schema-read\n        [group]=\"schemaPayload\"\n        [groupClass]=\"groupClass\"\n        [fieldClass]=\"fieldClass\"\n        [hideLabels]=\"hideLabels\"\n    ></anj-schema-read>\n</ng-container>\n<ng-template #formFields>\n    <anj-schema-group\n        [group]=\"schemaPayload\"\n        [groupClass]=\"groupClass\"\n        [fieldClass]=\"fieldClass\"\n        [hideLabels]=\"hideLabels\"\n        (valueChange)=\"updateApp($event)\"\n    ></anj-schema-group>\n</ng-template>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
SchemaContextComponent.ctorParameters = () => [];
SchemaContextComponent.propDecorators = {
    groupClass: [{ type: Input }],
    fieldClass: [{ type: Input }],
    mode: [{ type: Input }],
    schema: [{ type: Input }],
    data: [{ type: Input }],
    context: [{ type: Input }],
    valueChange: [{ type: Output }],
    schemaGroup: [{ type: ViewChild, args: [SchemaGroupComponent, { static: false },] }],
    classList: [{ type: HostBinding, args: ['class',] }],
    _fieldClass: [{ type: HostBinding, args: ['attr.fieldClass',] }],
    _groupClass: [{ type: HostBinding, args: ['attr.groupClass',] }],
    _mode: [{ type: HostBinding, args: ['attr.mode',] }]
};
if (false) {
    /** @type {?} */
    SchemaContextComponent.prototype.schema;
    /** @type {?} */
    SchemaContextComponent.prototype.data;
    /** @type {?} */
    SchemaContextComponent.prototype.context;
    /** @type {?} */
    SchemaContextComponent.prototype.valueChange;
    /** @type {?} */
    SchemaContextComponent.prototype.schemaGroup;
    /** @type {?} */
    SchemaContextComponent.prototype.schemaPayload;
    /** @type {?} */
    SchemaContextComponent.prototype._fieldClass;
    /** @type {?} */
    SchemaContextComponent.prototype._groupClass;
    /** @type {?} */
    SchemaContextComponent.prototype._mode;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function FieldItems() { }
if (false) {
    /** @type {?} */
    FieldItems.prototype.title;
    /** @type {?} */
    FieldItems.prototype.type;
    /** @type {?} */
    FieldItems.prototype.enum;
    /** @type {?|undefined} */
    FieldItems.prototype.properties;
}
/**
 * @record
 */
function SchemaData() { }
/**
 * @record
 */
function Relationship() { }
if (false) {
    /** @type {?} */
    Relationship.prototype.cardinality;
    /** @type {?} */
    Relationship.prototype.fields;
    /** @type {?} */
    Relationship.prototype.namespace;
    /** @type {?} */
    Relationship.prototype.object;
}
/**
 * @record
 */
function SchemaDefinition() { }
if (false) {
    /** @type {?|undefined} */
    SchemaDefinition.prototype.additionalProperties;
    /** @type {?|undefined} */
    SchemaDefinition.prototype.indexed;
    /** @type {?} */
    SchemaDefinition.prototype.properties;
    /** @type {?|undefined} */
    SchemaDefinition.prototype.relationships;
    /** @type {?|undefined} */
    SchemaDefinition.prototype.readOnlyOnUI;
    /** @type {?|undefined} */
    SchemaDefinition.prototype.required;
    /** @type {?} */
    SchemaDefinition.prototype.type;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const translations = {
    en: {
        'is required.': 'is required.',
        'is not a valid date.': 'is not a valid date.',
        'Please select an option.': 'Please select an option.',
        'must be at least': 'must be at least',
        'must not be greater than': 'must not be greater than',
        'must not have duplicate values.': 'must not have duplicate values.',
        'must have at least': 'must have at least',
        'entries.': 'entries.',
        'characters.': 'characters.',
        'must adhere to a specific pattern': 'must adhere to a specific pattern',
        'must adhere to an email pattern (ex. name@domain.com)': 'must adhere to an email pattern (ex. name@domain.com)',
        'Add an item below': 'Add an item below',
        'Remove this item': 'Remove this item',
        'Add a row below': 'Add a row below',
        'Remove this row': 'Remove this row',
    },
    fr: {
        'is required.': 'est obligatoire.',
        'is not a valid date.': 'n’est pas une date valide.',
        'Please select an option.': 'Sélectionnez une option.',
        'must be at least': 'doit être au moins',
        'must not be greater than': 'ne doit pas dépasser',
        'must not have duplicate values.': 'ne doit pas inclure de valeurs dupliquées.',
        'must have at least': 'doit inclure au moins',
        'entries.': 'entrées.',
        'characters.': 'caractères.',
        'must adhere to a specific pattern': 'doit correspondre à un format spécifique',
        'must adhere to an email pattern (ex. name@domain.com)': 'doit correspondre à un format d’e-mail (par ex., nom@domaine.com)',
        'Add an item below': 'Ajouter un élément ci-dessous',
        'Remove this item': 'Supprimer cet élément',
        'Add a row below': 'Ajouter une ligne ci-dessous',
        'Remove this row': 'Supprimer cette ligne',
    },
    de: {
        'is required.': 'ist erforderlich.',
        'is not a valid date.': 'ist kein gültiges Datum.',
        'Please select an option.': 'Wählen Sie eine Option aus.',
        'must be at least': 'muss mindestens folgenden Wert haben:',
        'must not be greater than': 'darf nicht größer als folgender Wert sein:',
        'must not have duplicate values.': 'darf keine duplizierten Werte aufweisen.',
        'must have at least': 'muss mindestens',
        'entries.': 'Einträge aufweisen.',
        'characters.': 'Zeichen lang sein.',
        'must adhere to a specific pattern': 'muss ein bestimmtes Muster befolgen',
        'must adhere to an email pattern (ex. name@domain.com)': 'muss ein bestimmtes E-Mail-Muster befolgen (Bsp.: name@domain.com)',
        'Add an item below': 'Element unterhalb hinzufügen',
        'Remove this item': 'Dieses Element entfernen',
        'Add a row below': 'Zeile unterhalb hinzufügen',
        'Remove this row': 'Diese Zeile entfernen',
    },
    ja: {
        'is required.': 'は必須です。',
        'is not a valid date.': 'は有効な日付ではありません。',
        'Please select an option.': 'オプションを選択してください。',
        'must be at least': 'の最小長さは',
        'must not be greater than': 'の最大長さは',
        'must not have duplicate values.': 'の値は重複させることはできません。',
        'must have at least': 'には少なくとも',
        'entries.': '個のエントリが必要です。',
        'characters.': '文字にする必要があります。',
        'must adhere to a specific pattern': 'は指定のパターン',
        'must adhere to an email pattern (ex. name@domain.com)': 'は電子メールのパターン (name@domain.com など) に従う必要があります',
        'Add an item below': '以下のアイテムを追加',
        'Remove this item': 'このアイテムを削除',
        'Add a row below': '以下の行を追加',
        'Remove this row': 'この行を削除',
    },
    es: {
        'is required.': 'es obligatoria.',
        'is not a valid date.': 'no es una fecha válida',
        'Please select an option': 'Por favor, seleccione una opción',
        'must be at least': 'debe ser al menos',
        'must not be greater than': 'no debe ser mayor que',
        'must not have duplicate values': 'no debe contener valores duplicados',
        'must have at least': 'debe tener al menos',
        'entries.': 'entradas.',
        'characters.': 'caracteres.',
        'must adhere to a specific pattern': 'debe ajustarse a un patrón específico',
        'must adhere to an email pattern (ex. name@domain.com)': 'debe adherirse a un patrón de correo electrónico (por ejemplo, nombre@dominio.com)',
        'Add an item below': 'Agregar un elemento abajo',
        'Remove this item': 'Eliminar este elemento',
        'Add a row below': 'Agregar una fila abajo',
        'Remove this row': 'Eliminar esta fila'
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * \@internal
 */
class SchemaTranslationPipe extends BaseTranslationPipe {
    constructor() {
        super(...arguments);
        this.translations = translations;
    }
}
SchemaTranslationPipe.decorators = [
    { type: Pipe, args: [{
                name: 'anjSchemaTranslate'
            },] }
];
if (false) {
    /**
     * @type {?}
     * @protected
     */
    SchemaTranslationPipe.prototype.translations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SchemaTierComponent extends SchemaTableComponent {
    /**
     * @param {?} changeRef
     * @param {?} el
     */
    constructor(changeRef, el) {
        super(changeRef);
        this.el = el;
        this.uom = { value: 1 };
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        super.ngOnInit();
        console.log(this.field, '<<');
        this.uoms = (this.field.uoms)
            ? this.field.uoms.map((/**
             * @param {?} f
             * @return {?}
             */
            f => ({ name: f.name, value: Number.parseFloat(f.value) })))
            : undefined;
        /** @type {?} */
        const initialSchemaUOM = this.uoms.find((/**
         * @param {?} u
         * @return {?}
         */
        u => u.name === this.field.uom));
        this.uom = initialSchemaUOM || { value: 1 };
        this.refreshTiers();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _onRowAdd(event) {
        /** @type {?} */
        const length = this.control.length;
        this.addRow(1, length);
    }
    // Passthrough to manage the readonly features of the first column (sparing the first row)
    /**
     * @param {?} column
     * @param {?} rowIndex
     * @return {?}
     */
    getField(column, rowIndex) {
        /** @type {?} */
        const columnIndex = this.findIndex(this.field.parsedArray, column);
        /** @type {?} */
        const field = this.field.parsedArray[columnIndex];
        ((/** @type {?} */ (field)))['readonly'] = !!(columnIndex === 0 && rowIndex > 0);
        return field;
    }
    /**
     * @param {?} index
     * @return {?}
     */
    tierToChange(index) {
        /** @type {?} */
        const nextRow = this.control.at(index + 1);
        /** @type {?} */
        const currentRowTierTo = this.control.at(index).get('tierTo').value;
        if (nextRow) {
            nextRow.patchValue({ tierFrom: currentRowTierTo + this.uom.value });
        }
    }
    /**
     * @param {?} __0
     * @return {?}
     */
    setUom({ detail }) {
        this.uom = detail.value;
        /** @type {?} */
        const domEvent = new CustomEvent('uomChange', {
            detail: this.uom,
            bubbles: true
        });
        this.el.nativeElement.dispatchEvent(domEvent);
        this.refreshTiers();
    }
    /**
     * @protected
     * @return {?}
     */
    newItem() {
        /** @type {?} */
        const group = SchemaFormService.generateFormGroup(this.field.parsedArray, {});
        /** @type {?} */
        const previousTier = this.control.at(this.control.length - 1);
        /** @type {?} */
        const previousTierTo = previousTier ? Number.parseFloat(previousTier.get('tierTo').value) : 0;
        group.patchValue({ tierFrom: previousTierTo + this.uom.value });
        return group;
    }
    /**
     * @private
     * @return {?}
     */
    refreshTiers() {
        /** @type {?} */
        const controls = this.control.controls;
        for (let i = 0; i < controls.length; i++) {
            if (i > 0) {
                /** @type {?} */
                const previousTier = controls[i - 1].value;
                /** @type {?} */
                const endingUnit = Number.parseFloat(previousTier.tierTo);
                controls[i].patchValue({ tierFrom: endingUnit + this.uom.value });
            }
        }
        this.acknowledgeChange();
    }
}
SchemaTierComponent.decorators = [
    { type: Component, args: [{
                selector: 'anj-schema-tier',
                template: "<anj-form-group class=\"anj-schema-table-label\">\n    <anj-label *ngIf=\"!hideLabels\" [fixed]=\"true\">{{label}}</anj-label>\n</anj-form-group>\n<anj-table [dataSource]=\"localControlValue\" column-width=\"auto-fix\" height=\"400px\">\n    <anj-editing\n        mode=\"batch\"\n        creating=\"true\"\n        deleting=\"true\"\n        saving=\"false\"\n        [deleteDisabled]=\"atMinItems()\"\n        [createDisabled]=\"atMaxItems()\"\n    ></anj-editing>\n    <anj-column *ngFor=\"let key of fieldItemPropertiesKeys; let index = index;\"\n                [dataType]=\"getDataType(field.parsedArray[index])\"\n                [field]=\"key\"\n                sortable=\"false\"\n                edit-template=\"controlTemplate\"\n    ></anj-column>\n    <ng-container *anjTemplate=\"let row of 'controlTemplate'; let i = index; let c = column;\">\n        <anj-schema-field\n            *ngIf=\"control.controls[i]\"\n            [field]=\"getField(c, i)\"\n            [control]=\"control.controls[i]['controls'][c.field]\"\n            [index]=\"i\"\n            [hideLabels]=\"true\"\n            (tierToChange)=\"tierToChange($event)\">\n        </anj-schema-field>\n    </ng-container>\n</anj-table>\n<anj-form-group *ngIf=\"uoms\">\n    <anj-label>Unit of Measurement</anj-label>\n    <anj-select (anjChange)=\"setUom($event)\" [value]=\"uom\">\n        <anj-option *ngFor=\"let u of uoms\" [value]=\"u\">{{u.name}}</anj-option>\n    </anj-select>\n</anj-form-group>\n",
                styles: ["anj-schema-table .anj-schema-table-label{margin-top:1rem}anj-schema-table anj-schema-field{display:block}"]
            }] }
];
/** @nocollapse */
SchemaTierComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ElementRef }
];
if (false) {
    /** @type {?} */
    SchemaTierComponent.prototype.uom;
    /** @type {?} */
    SchemaTierComponent.prototype.uoms;
    /** @type {?} */
    SchemaTierComponent.prototype.el;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AnjunaMetaUIModule {
}
AnjunaMetaUIModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    FieldTemplateDirective,
                    SchemaFieldComponent,
                    SchemaFormComponent,
                    SchemaGroupComponent,
                    SchemaNestedFieldComponent,
                    SchemaTranslationPipe,
                    SchemaReadComponent,
                    SchemaTableComponent,
                    ReadFieldComponent,
                    SchemaContextComponent,
                    SchemaTierComponent
                ],
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    FormsModule,
                    AnjunaCoreModule
                ],
                exports: [
                    FieldTemplateDirective,
                    SchemaFieldComponent,
                    SchemaFormComponent,
                    SchemaGroupComponent,
                    SchemaNestedFieldComponent,
                    SchemaReadComponent,
                    SchemaTableComponent,
                    ReadFieldComponent,
                    SchemaContextComponent
                ],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AnjunaMetaUIModule, ParsedField, ReadFieldComponent, SchemaContextComponent, SchemaFieldComponent, SchemaForm, SchemaFormComponent, SchemaFormService, SchemaGroupComponent, SchemaNestedFieldComponent, SchemaReadComponent, SchemaTableComponent, SchemaField as ɵa, BaseSchema as ɵb, SchemaControl as ɵc, FieldTemplateDirective as ɵd, SchemaGroup as ɵe, SchemaArray as ɵf, SchemaTranslationPipe as ɵg, SchemaTierComponent as ɵh };
//# sourceMappingURL=anjuna-angular-meta-ui.js.map
