import { ChangeDetectorRef, EventEmitter, OnChanges, OnDestroy } from '@angular/core';
import { FormGroup, FormGroupDirective } from '@angular/forms';
import { SchemaGroup } from '../abstracts/SchemaGroup';
import { SchemaData, ParsedSchemaPayload } from '../types/schema-form.types';
export declare class SchemaGroupComponent extends SchemaGroup implements OnChanges, OnDestroy {
    private changeRef;
    private parentGroup;
    /**
     * an object full of keys corresponding to field names
     * ex: custom_field__c
     * matched to functions that return a promise,
     * well suited for onChange, onClick, onDrag event situations
     */
    onInputChangeCallbacks: {
        [key: string]: () => Promise<any>;
    };
    valueChange: EventEmitter<SchemaData>;
    readonly classList: string;
    formGroup: FormGroup;
    private groupSubscription;
    constructor(changeRef: ChangeDetectorRef, parentGroup: FormGroupDirective);
    ngOnChanges(): void;
    ngOnDestroy(): void;
    /**
     * @description initializes a schema group imperatively
     */
    initFormGroup([fields, group]: ParsedSchemaPayload): void;
    getInputChangeCallback(fieldName: string): () => Promise<any>;
    protected initGroup(): void;
}
